LPARAMETERS _thisform, llOpTip, lnBusena1, lnBusena2, lnBusena3, llIstorija, llSablonai

ON ERROR

IF !test_vps(.T.) && Patikriname ar yra aktyvus VPS
	RETURN .F.
ENDIF

IF !m.llOpTip
	=f_busena_sql(_thisform)
	RETURN .T.
ENDIF

IF !INLIST(m.BUSENOS_MODULIS,"OD","PO","RO")
	=l_MESSAGEBOX("Programa skirta tik DVS, Pirkim ir Pardavim moduliams",16,"Klaida")
	RETURN .F.
ENDIF

LOCAL lcSablKodas
IF m.BUSENOS_MODULIS="OD"
	m.lcSablKodas='MG_K42_OD_'
ENDIF
IF m.BUSENOS_MODULIS="PO"
	m.lcSablKodas='MG_I06_PO_'
ENDIF
IF m.BUSENOS_MODULIS="RO"
	m.lcSablKodas='MG_I06_RO_'
ENDIF

** Parenkame sekani bsen
Dimension mano_pasirinkimo_masyvas(4)
mano_pasirinkimo_masyvas(1)=l_tek("(1) Vizavimas")
mano_pasirinkimo_masyvas(2)=l_tek("(2) Pasiraymas, Vizavimas")
mano_pasirinkimo_masyvas(3)=l_tek("(3) Pasiraymas, Tvirtinimas, Vizavimas")
mano_pasirinkimo_masyvas(4)=l_tek("(4) Pagal pasirinkt ablonin operacij")

LOCAL lnLygis
lnLygis=ps_kod(,"Pasirinkite tvirtinimo lyg",,,,"P",,,,@mano_pasirinkimo_masyvas)

IF EMPTY(m.lnLygis)
	RETURN .F.
ENDIF

PRIVATE pcKodas_op
m.pcKodas_op=""
IF lnLygis=4
	m.pcKodas_op=ps_kod(m.BUSENOS_MODULIS)
	IF EMPTY(m.pcKodas_op)
		RETURN .F.
	ENDIF
	=f_select("select top 1 K64_KODAS_VU, CAST(LEFT(RIGHT(RTRIM(K64_KODAS_VU),2),1) as int) as lygis from K64_VARL where K64_KODAS_OP=?m.pcKodas_op and K64_KODAS_VU like '"+lcSablKodas+"[1-3]1' order by K64_KODAS_VU asc","K64_TEST")
	GO TOP IN K64_TEST
	IF EOF("K64_TEST")
		l_MESSAGEBOX("Nurodyta operacija neturi aprayt tvirtinim",16,"Klaida")
		USE IN K64_TEST
		RETURN .F.
	ENDIF
	m.lnLygis=K64_TEST.lygis
	USE IN K64_TEST
ENDIF

IF !BETWEEN(m.lnLygis,1,3)
	l_MESSAGEBOX("Neinomas tvirtinimo lygis!",16,"Klaida")
	RETURN .F.
ENDIF

IF m.lnLygis=1
	m.BUSENOS_NAUJA=m.lnBusena1
ENDIF
IF m.lnLygis=2
	m.BUSENOS_NAUJA=m.lnBusena2
ENDIF
IF m.lnLygis=3
	m.BUSENOS_NAUJA=m.lnBusena3
ENDIF

** Parenkame tvirtinimo eig
PRIVATE pnBusena
LOCAL llRet, lnPrivaloma, lcLygisPref
m.llRet=.T.
m.lnPrivaloma=2 && 2
m.lcLygisPref=STR(lnLygis,1,0)

IF m.llRet AND lnLygis>=1
	m.pnBusena=m.BUSENOS_NAUJA+0
	IF !EMPTY(llSablonai)
		=x_vizavimas_leisti(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'1')
	ENDIF
	IF !EMPTY(llIstorija)
		IF m.BUSENOS_MODULIS="OD"
			=x_vizavimas_od_istorija(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'1',@pcKodas_op)
		ENDIF
		IF m.BUSENOS_MODULIS="PO" OR m.BUSENOS_MODULIS="RO"
			=x_vizavimas_po_istorija(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'1',@pcKodas_op)
		ENDIF
	ENDIF
	=f_select("select L19_PAV from L19_BUS where L19_MODUL=?m.BUSENOS_MODULIS and L19_BUSENA=?m.pnBusena","L19")
	m.llRet=mgama_vart_forma(m.lcLygisPref+"1",_thisform,m.lnPrivaloma, .F., .F., ALLTRIM(L19.l19_pav))
ENDIF

IF m.llRet AND lnLygis>=2
	m.pnBusena=m.BUSENOS_NAUJA+1
	IF !EMPTY(llSablonai)
		=x_vizavimas_leisti(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'2')
	ENDIF
	IF !EMPTY(llIstorija)
		IF m.BUSENOS_MODULIS="OD"
			=x_vizavimas_od_istorija(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'2',@pcKodas_op)
		ENDIF
		IF m.BUSENOS_MODULIS="PO" OR m.BUSENOS_MODULIS="RO"
			=x_vizavimas_po_istorija(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'2',@pcKodas_op)
		ENDIF
	ENDIF
	=f_select("select L19_PAV from L19_BUS where L19_MODUL=?m.BUSENOS_MODULIS and L19_BUSENA=?m.pnBusena","L19")
	m.llRet=mgama_vart_forma(m.lcLygisPref+"2",_thisform,m.lnPrivaloma, .F., .F., ALLTRIM(L19.l19_pav))
ENDIF

IF m.llRet AND lnLygis>=3
	m.pnBusena=m.BUSENOS_NAUJA+2
	IF !EMPTY(llSablonai)
		=x_vizavimas_leisti(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'3')
	ENDIF
	IF !EMPTY(llIstorija)
		IF m.BUSENOS_MODULIS="OD"
			=x_vizavimas_od_istorija(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'3',@pcKodas_op)
		ENDIF
		IF m.BUSENOS_MODULIS="PO" OR m.BUSENOS_MODULIS="RO"
			=x_vizavimas_po_istorija(m.pnBusena,m.lcSablKodas+m.lcLygisPref+'3',@pcKodas_op)
		ENDIF
	ENDIF
	=f_select("select L19_PAV from L19_BUS where L19_MODUL=?m.BUSENOS_MODULIS and L19_BUSENA=?m.pnBusena","L19")
	m.llRet=mgama_vart_forma(m.lcLygisPref+"3",_thisform,m.lnPrivaloma, .F., .F., ALLTRIM(L19.l19_pav))
ENDIF

IF m.llRet
	=f_busena_sql(_thisform)
ENDIF

RETURN m.llRet








PROCEDURE x_vizavimas_leisti
LPARAMETERS lnBusena, lcKodas_vu, lcKodas_vu_sabl
PRIVATE pcKodas_vu, lcKodas_vu_busena, pnBusena
m.pcKodas_vu=m.lcKodas_vu
m.pcKodas_vu_sabl=m.lcKodas_vu_sabl
m.pnBusena=m.lnBusena
IF EMPTY(m.pcKodas_vu_sabl)
	m.pcKodas_vu_sabl='MG_L19_BE_PP'
ENDIF
** Parenkame KODAS_BE, pagal nauj bsen
=f_select(	" select L19_KODAS_BE from L19_BUS where L19_MODUL=?m.BUSENOS_MODULIS and L19_BUSENA=?m.pnBusena","L19")
** Itriname senus sudtus leidimus
=f_select(	" delete from K64_VARL where K64_KODAS_VU=?m.pcKodas_vu and K64_KODAS_OP=?m.BUSENOS_OP_NR")
** Sukeliame leidimus pagal ablon
=f_select(	" insert into K64_VARL (K64_KODAS_VU, K64_KODAS_OP, K64_KODAS_RS, K64_USERIS, K64_R_DATE) "+;
			" select ?m.pcKodas_vu as kodas_vu, ?m.BUSENOS_OP_NR as kodas_op, K64_KODAS_RS, ?titi_pagr.useris as useris, ?titi_pagr.date as r_date "+;
			" from K64_VARL where K64_KODAS_VU=?m.pcKodas_vu_sabl and K64_KODAS_OP=?L19.L19_KODAS_BE")
**-
RETURN .T.
ENDPROC







PROCEDURE x_vizavimas_od_istorija
LPARAMETERS lnBusena, lcKodas_vu, lcKodas_op
PRIVATE pcKodas_vu, pnBusena, pcKodas_op
m.pcKodas_vu=m.lcKodas_vu
m.pnBusena=m.lnBusena
m.pcKodas_op=m.lcKodas_op
** Surandame paskutin tvirtint operacij
IF EMPTY(m.pcKodas_op)
	=f_seek("K42",m.BUSENOS_OP_NR) && esama operacija
	=f_select(	" select top 1 K42_KODAS_OD from K42_OD"+;
				" where K42_TIPAS=?K42.k42_tipas and K42_KODAS_RD=?K42.k42_kodas_rd"+;
				" 	and k42_kodas_od in (select K64_KODAS_OP from K64_VARL where K64_KODAS_VU=?m.pcKodas_vu group by K64_KODAS_OP)"+;
				" 	and k42_kodas_od<>?m.BUSENOS_OP_NR"+;
				" order by K42_OP_DATA desc";
				,"K42_SABL")
	GO TOP IN K42_SABL
	IF EOF("K42_SABL")
		USE IN K42_SABL
		RETURN .F.
	ENDIF
	m.pcKodas_op=K42_SABL.K42_KODAS_OD
	USE IN K42_SABL
	USE IN K42
ENDIF
** Itriname senus sudtus leidimus
=f_select(	" delete from K64_VARL where K64_KODAS_VU=?m.pcKodas_vu and K64_KODAS_OP=?m.BUSENOS_OP_NR")
** Sukeliame leidimus pagal ablon
=f_select(	" insert into K64_VARL (K64_KODAS_VU, K64_KODAS_OP, K64_KODAS_RS, K64_USERIS, K64_R_DATE) "+;
			" select K64_KODAS_VU, ?m.BUSENOS_OP_NR as kodas_op, K64_KODAS_RS, ?titi_pagr.useris as useris, ?titi_pagr.date as r_date "+;
			" from K64_VARL where K64_KODAS_OP=?m.pcKodas_op and K64_KODAS_VU=?m.pcKodas_vu")
**-
m.lcKodas_op=m.pcKodas_op
RETURN .T.
ENDPROC



PROCEDURE x_vizavimas_po_istorija
LPARAMETERS lnBusena, lcKodas_vu, lcKodas_op
PRIVATE pcKodas_vu, lcKodas_vu_busena, pnBusena, pcKodas_op
m.pcKodas_vu=m.lcKodas_vu
m.pnBusena=m.lnBusena
m.pcKodas_op=m.lcKodas_op
** Surandame paskutin tvirtint operacij
IF EMPTY(m.pcKodas_op)
	=f_seek("I06",m.BUSENOS_OP_NR) && esama operacija
	=f_select(	" select top 1 I06_KODAS_PO from I06_PARH"+;
				" where I06_OP_TIP=?I06.i06_op_tip and I06_KODAS_KS=?I06.i06_kodas_ks"+;
				" 	and i06_kodas_po in (select K64_KODAS_OP from K64_VARL where K64_KODAS_VU=?m.pcKodas_vu group by K64_KODAS_OP)"+;
				" 	and i06_kodas_po<>?m.BUSENOS_OP_NR"+;
				" order by I06_OP_DATA desc";
				,"I06_SABL")
	GO TOP IN I06_SABL
	IF EOF("I06_SABL")
		USE IN I06_SABL
		RETURN .F.
	ENDIF
	m.pcKodas_op=I06_SABL.I06_KODAS_PO
	USE IN I06_SABL
	USE IN I06
ENDIF
** Itriname senus sudtus leidimus
=f_select(	" delete from K64_VARL where K64_KODAS_VU=?m.pcKodas_vu and K64_KODAS_OP=?m.BUSENOS_OP_NR")
** Sukeliame leidimus pagal ablon
=f_select(	" insert into K64_VARL (K64_KODAS_VU, K64_KODAS_OP, K64_KODAS_RS, K64_USERIS, K64_R_DATE) "+;
			" select K64_KODAS_VU, ?m.BUSENOS_OP_NR as kodas_op, K64_KODAS_RS, ?titi_pagr.useris as useris, ?titi_pagr.date as r_date "+;
			" from K64_VARL where K64_KODAS_OP=?m.pcKodas_op and K64_KODAS_VU=?m.pcKodas_vu")
**-
m.lcKodas_op=m.pcKodas_op
RETURN .T.
ENDPROC
